#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "cmd.h"
#include "dinput.h"

extern Line **lines;
extern unsigned int aline;
extern Bool running;

#define alptr (lines[aline]->l)
#define apptr (lines[aline]->l + lines[aline]->p)

void cmd_exec(char *cmd) 
{
  char *newcmd = emalloc(strlen(cmd) + 3);
  newcmd = strcat(newcmd, cmd);
  newcmd = strcat(newcmd, " &");
  /* Execte */
  system(newcmd);
  /* Free the newly createt command */
  free(newcmd);
}

void cmd_exit(char *cmd) 
{
  if (*cmd)
    printf("%s\n", cmd);
  running = False;
}

void cmd_insert(char *cmd) 
{
  insert_string(cmd);
  drawmenu();
}

void cmd_popen(char *cmd) 
{
  char buf[50];
  FILE *process = popen(cmd, "r");
  if (!process)
    eprint("couldn't popen");

  while (fgets(buf, sizeof(buf), process)) {
    if (buf[strlen(buf) - 1] == '\n') buf[strlen(buf) - 1] = 0;
    insert_string(buf);
  }
  fclose(process);
  drawmenu();
}

void cmd_pipe(char *cmd) 
{
  char buf[50];
  char *argv[] = {"sh", "-c", cmd, NULL};
  FILE *input, *output;
  if(pipe_execv(&input, &output, NULL, "/bin/sh",  argv) < 2) 
    eprint("couldn't popen");

  fwrite(lines[aline]->l, strlen(lines[aline]->l), 1, input);
  fclose(input);

  /* reset line */
  lines[aline]->l[0] = 0;
  lines[aline]->p = 0;

  while (fgets(buf, sizeof(buf), output)) {
    if (buf[strlen(buf) - 1] == '\n') buf[strlen(buf) - 1] = 0;
    insert_string(buf);
  }
  fclose(output);
  drawmenu();
}

void cmd_jump(char *cmd) 
{
  int position = strtol(cmd, NULL, 10);
  if (position == -1) 
    lines[aline]->p = strlen(lines[aline]->l);
  else {
    if (position > strlen(lines[aline]->l))
      lines[aline]->p = strlen(lines[aline]->l);
    else 
      lines[aline]->p = position;
  }
  drawmenu();
}
